org.apache.ignite.internal.processors.hadoop

## Enum HadoopJobProperty

- java.lang.Object
- - java.lang.Enum<HadoopJobProperty>
  - - org.apache.ignite.internal.processors.hadoop.HadoopJobProperty

All Implemented Interfaces:
  Serializable, Comparable<HadoopJobProperty>

    public enum HadoopJobProperty
    extends Enum<HadoopJobProperty>

Enumeration of optional properties supported by Apache Ignite Hadoop Accelerator.

### Enum Constant Summary

Enum Constants
Enum Constant and Description
`COMBINER_HASHMAP_SIZE` Initial size for hashmap which stores output of mapper and will be used as input of combiner.
`EXTERNAL_CONCURRENT_MAPPERS` Specifies number of concurrently running mappers for external execution mode.
`EXTERNAL_CONCURRENT_REDUCERS` Specifies number of concurrently running reducers for external execution mode.
`JOB_PARTIALLY_RAW_COMPARATOR` Fully qualified name of partially raw comparator which should be used on sorting phase.
`JOB_SHARED_CLASSLOADER` Whether job classloader can be shared between all tasks.
`JOB_STATUS_POLL_DELAY` Delay in milliseconds after which Ignite server will reply job status.
`PARTITION_HASHMAP_SIZE` Initial size for hashmap which stores output of mapper or combiner and will be used as input of reducer.
`SHUFFLE_COMBINER_NO_SORTING` If set to `true` then input for combiner will not be sorted by key.
`SHUFFLE_JOB_THROTTLE` Shuffle job throttle in milliseconds.
`SHUFFLE_MAPPER_STRIPED_OUTPUT` Whether to stripe mapper output for remote reducers.
`SHUFFLE_MSG_GZIP` Whether shuffle message should be compressed with GZIP.
`SHUFFLE_MSG_SIZE` Defines approximate size in bytes of shuffle message which will be passed over wire from mapper to reducer.
`SHUFFLE_OFFHEAP_PAGE_SIZE` Size in bytes of single memory page which will be allocated for data structures in shuffle.
`SHUFFLE_REDUCER_NO_SORTING` If set to `true` then input for reducer will not be sorted by key.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`static boolean` `get(HadoopJobInfo jobInfo, HadoopJobProperty pty, boolean dflt)`
`static int` `get(HadoopJobInfo jobInfo, HadoopJobProperty pty, int dflt)`
`static String` `get(HadoopJobInfo jobInfo, HadoopJobProperty pty, String dflt)`
`String` `propertyName()`
`static HadoopJobProperty` `valueOf(String name)` Returns the enum constant of this type with the specified name.
`static HadoopJobProperty[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### COMBINER_HASHMAP_SIZE

    public static final HadoopJobProperty COMBINER_HASHMAP_SIZE

Initial size for hashmap which stores output of mapper and will be used as input of combiner.

Setting it right allows to avoid rehashing.

#### PARTITION_HASHMAP_SIZE

    public static final HadoopJobProperty PARTITION_HASHMAP_SIZE

Initial size for hashmap which stores output of mapper or combiner and will be used as input of reducer.

Setting it right allows to avoid rehashing.

#### EXTERNAL_CONCURRENT_MAPPERS

    public static final HadoopJobProperty EXTERNAL_CONCURRENT_MAPPERS

Specifies number of concurrently running mappers for external execution mode.

If not specified, defaults to `Runtime.getRuntime().availableProcessors()`.

#### EXTERNAL_CONCURRENT_REDUCERS

    public static final HadoopJobProperty EXTERNAL_CONCURRENT_REDUCERS

Specifies number of concurrently running reducers for external execution mode.

If not specified, defaults to `Runtime.getRuntime().availableProcessors()`.

#### JOB_STATUS_POLL_DELAY

    public static final HadoopJobProperty JOB_STATUS_POLL_DELAY

Delay in milliseconds after which Ignite server will reply job status.

#### JOB_SHARED_CLASSLOADER

    public static final HadoopJobProperty JOB_SHARED_CLASSLOADER

Whether job classloader can be shared between all tasks.

Defaults to `true`.

#### JOB_PARTIALLY_RAW_COMPARATOR

    public static final HadoopJobProperty JOB_PARTIALLY_RAW_COMPARATOR

Fully qualified name of partially raw comparator which should be used on sorting phase.

#### SHUFFLE_OFFHEAP_PAGE_SIZE

    public static final HadoopJobProperty SHUFFLE_OFFHEAP_PAGE_SIZE

Size in bytes of single memory page which will be allocated for data structures in shuffle.

Defaults to `1Mb`.

#### SHUFFLE_COMBINER_NO_SORTING

    public static final HadoopJobProperty SHUFFLE_COMBINER_NO_SORTING

If set to `true` then input for combiner will not be sorted by key. Internally hash-map will be used instead of sorted one, so `Object.equals(Object)` and `Object.hashCode()` methods of key must be implemented consistently with comparator for that type. Grouping comparator is not supported if this setting is `true`.

By default is `false`.

#### SHUFFLE_REDUCER_NO_SORTING

    public static final HadoopJobProperty SHUFFLE_REDUCER_NO_SORTING

If set to `true` then input for reducer will not be sorted by key. Internally hash-map will be used instead of sorted one, so `Object.equals(Object)` and `Object.hashCode()` methods of key must be implemented consistently with comparator for that type. Grouping comparator is not supported if this setting is `true`.

By default is `false`.

#### SHUFFLE_MSG_SIZE

    public static final HadoopJobProperty SHUFFLE_MSG_SIZE

Defines approximate size in bytes of shuffle message which will be passed over wire from mapper to reducer.

Defaults to `1Mb`.

#### SHUFFLE_MSG_GZIP

    public static final HadoopJobProperty SHUFFLE_MSG_GZIP

Whether shuffle message should be compressed with GZIP.

Defaults to `false`.

#### SHUFFLE_MAPPER_STRIPED_OUTPUT

    public static final HadoopJobProperty SHUFFLE_MAPPER_STRIPED_OUTPUT

Whether to stripe mapper output for remote reducers.

Defaults to `true`.

#### SHUFFLE_JOB_THROTTLE

    public static final HadoopJobProperty SHUFFLE_JOB_THROTTLE

Shuffle job throttle in milliseconds. When job is executed with separate shuffle thread, this parameter controls sleep duration between iterations through intermediate reducer maps.

Defaults to `0`.

### Method Detail

#### values

    public static HadoopJobProperty[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (HadoopJobProperty c : HadoopJobProperty.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static HadoopJobProperty valueOf(String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null

#### propertyName

    public String propertyName()

Returns:
  Property name.

#### get

    public static String get(HadoopJobInfo jobInfo,
                             HadoopJobProperty pty,
                             @Nullable
                             String dflt)

Parameters:
  `jobInfo` - Job info.
  `pty` - Property.
  `dflt` - Default value.
Returns:
  Property value.

#### get

    public static int get(HadoopJobInfo jobInfo,
                          HadoopJobProperty pty,
                          int dflt)

Parameters:
  `jobInfo` - Job info.
  `pty` - Property.
  `dflt` - Default value.
Returns:
  Property value.

#### get

    public static boolean get(HadoopJobInfo jobInfo,
                              HadoopJobProperty pty,
                              boolean dflt)

Parameters:
  `jobInfo` - Job info.
  `pty` - Property.
  `dflt` - Default value.
Returns:
  Property value.

2018 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Database and Caching Platform | : ver. 2.7.5
Release Date | : June 4 2019